"Installation script for weak classes and finalization.
The installation is a multi pass process:
	1) Install the necessary behaviour in ObjectMemory and Interpreter
	2) Install the modifications in Behavior and Class
	2) Install the WeakCollections
	3) Install the Socket & Stream modifications.
"
"<--------- Pass 1 ----------->"
(ObjectMemory canUnderstand: #finalizeReference:) ifFalse:[
	(FileStream oldFileNamed:'ObjectMemory-Finalization.st') fileIn.
].
(ObjectMemory canUnderstand: #isWeak:) ifFalse:[
	(FileStream oldFileNamed:'Interpreter-WeakClasses.st') fileIn.
].
(Interpreter canUnderstand: #signalFinalization:) ifFalse:[
	(FileStream oldFileNamed: 'Interpreter-Finalization.st') fileIn.
].
"<--------- Pass 2 ----------->"
(Behavior canUnderstand: #isWeak) ifFalse:[
	(FileStream oldFileNamed: 'Behavior-WeakClasses.st') fileIn.
].
"<--------- Pass 3 ----------->"
(Smalltalk includesKey: #WeakArray) ifFalse:[
	self inform:
'This script is about to install the weak collections.
If you get any error during the installation you''ll
have to build a new virtual machine first.'.
	(FileStream oldFileNamed:'WeakCollections.st') fileIn.
].
"<--------- Pass 4 ----------->"
(StandardFileStream includesSelector: #finalize) ifFalse:[
	(FileStream oldFileNamed:'Finalization-SockStream.st') fileIn.
].
self inform:'Installation successful - have fun.'.
